{
  "components": {
    "schemas": {
      "Actor": {
        "additionalProperties": false,
        "properties": {
          "auth": {
            "type": "string"
          },
          "groups": {
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "id": {
            "type": "string"
          },
          "kind": {
            "type": "string"
          },
          "name": {
            "type": "string"
          }
        },
        "type": "object"
      },
      "ApplyResult": {
        "additionalProperties": false,
        "properties": {
          "error": {
            "type": "string"
          },
          "errorKey": {
            "type": "string"
          },
          "hint": {
            "type": "string"
          },
          "kind": {
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "namespace": {
            "type": "string"
          },
          "resourceVersion": {
            "type": "string"
          },
          "result": {
            "enum": [
              "created",
              "updated",
              "unchanged",
              "error"
            ],
            "type": "string"
          }
        },
        "required": [
          "kind",
          "name",
          "result"
        ],
        "type": "object"
      },
      "AuditPage": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "type": "string"
          },
          "cursor_next": {
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/Event"
            },
            "type": "array"
          },
          "node": {
            "type": "string"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "node",
          "took_ms"
        ],
        "type": "object"
      },
      "AuthListIAMUser": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "type": "string"
          },
          "diagnoses": {
            "description": "Why entries were ignored (role bindings, identity providers).",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/IAMUser"
            },
            "type": "array"
          },
          "took_ms": {
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "items",
          "continue",
          "took_ms"
        ],
        "type": "object"
      },
      "AuthListIdentityProviderInfo": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "type": "string"
          },
          "diagnoses": {
            "description": "Why entries were ignored (role bindings, identity providers).",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/IdentityProviderInfo"
            },
            "type": "array"
          },
          "took_ms": {
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "items",
          "continue",
          "took_ms"
        ],
        "type": "object"
      },
      "AuthListRoleBindingInfo": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "type": "string"
          },
          "diagnoses": {
            "description": "Why entries were ignored (role bindings, identity providers).",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/RoleBindingInfo"
            },
            "type": "array"
          },
          "took_ms": {
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "items",
          "continue",
          "took_ms"
        ],
        "type": "object"
      },
      "AuthListServiceAccountInfo": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "type": "string"
          },
          "diagnoses": {
            "description": "Why entries were ignored (role bindings, identity providers).",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/ServiceAccountInfo"
            },
            "type": "array"
          },
          "took_ms": {
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "items",
          "continue",
          "took_ms"
        ],
        "type": "object"
      },
      "AuthListTokenInfo": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "type": "string"
          },
          "diagnoses": {
            "description": "Why entries were ignored (role bindings, identity providers).",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/TokenInfo"
            },
            "type": "array"
          },
          "took_ms": {
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "items",
          "continue",
          "took_ms"
        ],
        "type": "object"
      },
      "AuthProvider": {
        "additionalProperties": false,
        "properties": {
          "displayName": {
            "type": "string"
          },
          "id": {
            "type": "string"
          }
        },
        "required": [
          "id",
          "displayName"
        ],
        "type": "object"
      },
      "AuthSessionLimits": {
        "additionalProperties": false,
        "properties": {
          "idleTimeout": {
            "description": "Go duration (auth.session.idleTimeout).",
            "type": "string"
          },
          "lifetime": {
            "description": "Go duration (auth.session.lifetime).",
            "type": "string"
          }
        },
        "required": [
          "idleTimeout",
          "lifetime"
        ],
        "type": "object"
      },
      "AuthStatus": {
        "additionalProperties": false,
        "properties": {
          "hasDefaultCredentials": {
            "description": "The bootstrap admin still has its generated password.",
            "type": "boolean"
          },
          "localLogin": {
            "description": "False only when auth.localLogin is disabled.",
            "type": "boolean"
          },
          "localLoginMode": {
            "description": "auth.localLogin.",
            "enum": [
              "enabled",
              "admins-only",
              "disabled"
            ],
            "type": "string"
          },
          "providers": {
            "description": "The OIDC login options.",
            "items": {
              "$ref": "#/components/schemas/AuthProvider"
            },
            "type": "array"
          },
          "session": {
            "$ref": "#/components/schemas/AuthSessionLimits"
          }
        },
        "required": [
          "localLogin",
          "localLoginMode",
          "providers",
          "hasDefaultCredentials"
        ],
        "type": "object"
      },
      "BatchDeleteInputBody": {
        "additionalProperties": false,
        "properties": {
          "names": {
            "items": {
              "type": "string"
            },
            "maxItems": 1000,
            "minItems": 1,
            "type": [
              "array",
              "null"
            ]
          },
          "namespace": {
            "type": "string"
          }
        },
        "required": [
          "names"
        ],
        "type": "object"
      },
      "BindingScope": {
        "additionalProperties": false,
        "properties": {
          "kind": {
            "description": "cluster, zone, ...",
            "type": "string"
          },
          "name": {
            "type": "string"
          }
        },
        "required": [
          "kind"
        ],
        "type": "object"
      },
      "BindingSubject": {
        "additionalProperties": false,
        "properties": {
          "kind": {
            "description": "User, Group, ServiceAccount, ...",
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "namespace": {
            "type": "string"
          }
        },
        "required": [
          "kind",
          "name"
        ],
        "type": "object"
      },
      "BlockedItem": {
        "additionalProperties": false,
        "properties": {
          "client": {
            "type": "string"
          },
          "client_name": {
            "type": "string"
          },
          "domain": {
            "type": "string"
          },
          "id": {
            "format": "int64",
            "minimum": 0,
            "type": "integer"
          },
          "list": {
            "type": "string"
          },
          "status": {
            "type": "string"
          },
          "ts": {
            "format": "date-time",
            "type": "string"
          }
        },
        "required": [
          "id",
          "ts",
          "domain",
          "client",
          "status"
        ],
        "type": "object"
      },
      "BlockingState": {
        "additionalProperties": false,
        "properties": {
          "blocking": {
            "type": "boolean"
          },
          "configured": {
            "type": "boolean"
          },
          "node": {
            "type": "string"
          },
          "scope": {
            "enum": [
              "node",
              "cluster"
            ],
            "type": "string"
          },
          "timer": {
            "format": "double",
            "type": "number"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "until": {
            "format": "date-time",
            "type": "string"
          }
        },
        "required": [
          "blocking",
          "configured",
          "scope",
          "node",
          "took_ms"
        ],
        "type": "object"
      },
      "CatalogueCategory": {
        "additionalProperties": false,
        "properties": {
          "description": {
            "type": "string"
          },
          "icon": {
            "description": "A Lucide icon name (kebab-case).",
            "type": "string"
          },
          "id": {
            "description": "The ID Policy.spec.blockedCategories names.",
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "order": {
            "description": "Sort order (ascending).",
            "format": "int64",
            "type": "integer"
          },
          "services": {
            "description": "Services in the category.",
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "id",
          "name",
          "order",
          "services"
        ],
        "type": "object"
      },
      "CatalogueIcon": {
        "additionalProperties": false,
        "properties": {
          "id": {
            "description": "The icon slug (the homarr-labs/dashboard-icons file name).",
            "type": "string"
          },
          "onDark": {
            "description": "Path of the variant for dark backgrounds, when one exists.",
            "type": "string"
          },
          "path": {
            "description": "/api/v1/catalogue/icons/{id}.svg",
            "type": "string"
          }
        },
        "required": [
          "id",
          "path"
        ],
        "type": "object"
      },
      "CatalogueInfo": {
        "additionalProperties": false,
        "properties": {
          "categories": {
            "format": "int64",
            "type": "integer"
          },
          "digest": {
            "description": "SHA-256 of the catalogue document.",
            "type": "string"
          },
          "homepage": {
            "type": "string"
          },
          "license": {
            "description": "SPDX licence of the catalogue data.",
            "type": "string"
          },
          "origin": {
            "description": "\"embedded\" (built into the binary) or the blocking.catalogue.url it was downloaded from.",
            "type": "string"
          },
          "refresh": {
            "$ref": "#/components/schemas/CatalogueRefresh"
          },
          "safeSearchEngines": {
            "format": "int64",
            "type": "integer"
          },
          "schemaVersion": {
            "description": "Catalogue document schema version.",
            "format": "int64",
            "type": "integer"
          },
          "services": {
            "format": "int64",
            "type": "integer"
          },
          "sources": {
            "items": {
              "$ref": "#/components/schemas/CatalogueSourceInfo"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "version": {
            "description": "Catalogue version (YYYY.MM.DD).",
            "type": "string"
          }
        },
        "required": [
          "schemaVersion",
          "version",
          "license",
          "origin",
          "digest",
          "services",
          "categories",
          "safeSearchEngines",
          "sources",
          "took_ms"
        ],
        "type": "object"
      },
      "CatalogueRefresh": {
        "additionalProperties": false,
        "properties": {
          "lastAttempt": {
            "format": "date-time",
            "type": "string"
          },
          "lastError": {
            "type": "string"
          },
          "lastSuccess": {
            "format": "date-time",
            "type": "string"
          },
          "url": {
            "type": "string"
          }
        },
        "required": [
          "url"
        ],
        "type": "object"
      },
      "CatalogueService": {
        "additionalProperties": false,
        "properties": {
          "category": {
            "description": "The category ID (GET /catalogue/categories): ai, social, video, ...",
            "type": "string"
          },
          "domains": {
            "description": "The service's rules as list text (||domain^).",
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "icon": {
            "description": "Logo path, /api/v1/catalogue/icons/{slug}.svg; absent when there is none.",
            "type": "string"
          },
          "iconOnDark": {
            "description": "The logo drawn for dark backgrounds, when the default one is dark artwork.",
            "type": "string"
          },
          "id": {
            "description": "The ID Policy.spec.blockedServices names.",
            "type": "string"
          },
          "license": {
            "description": "SPDX licence of the entry (Apache-2.0, or GPL-3.0 for imported services).",
            "type": "string"
          },
          "list": {
            "description": "The list name the query log records for this service's blocks (service:\u003cid\u003e).",
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "note": {
            "description": "A caveat about blocking the service.",
            "type": "string"
          },
          "origin": {
            "description": "kudurru, or adguard for a service of the opt-in AdGuard import.",
            "enum": [
              "kudurru",
              "adguard"
            ],
            "type": "string"
          },
          "related": {
            "description": "Services of the same vendor or closely tied to it.",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "requires": {
            "description": "Services this one also depends on: block them too to stop it (Fortnite requires epicgames).",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "rules": {
            "description": "Number of rules (||domain^).",
            "format": "int64",
            "type": "integer"
          },
          "source": {
            "description": "Where the entry comes from: a vendor documentation URL or \"first-party domains of the service\"; adguard-hostlists-registry for imported services.",
            "type": "string"
          }
        },
        "required": [
          "id",
          "name",
          "category",
          "list",
          "rules",
          "domains",
          "source",
          "origin",
          "license"
        ],
        "type": "object"
      },
      "CatalogueSourceInfo": {
        "additionalProperties": false,
        "properties": {
          "digest": {
            "description": "SHA-256 of the document in service; absent before the first successful download.",
            "type": "string"
          },
          "droppedRules": {
            "description": "Imported rules left out because they are not plain block rules.",
            "format": "int64",
            "type": "integer"
          },
          "id": {
            "description": "kudurru: the catalogue document (embedded or blocking.catalogue.url). adguard: the opt-in import of blocking.catalogue.adguardServicesURL.",
            "enum": [
              "kudurru",
              "adguard"
            ],
            "type": "string"
          },
          "license": {
            "description": "SPDX licence of the source's data (Apache-2.0 for kudurru, GPL-3.0 for AdGuard's).",
            "type": "string"
          },
          "loaded": {
            "description": "A document of this source is in service.",
            "type": "boolean"
          },
          "name": {
            "type": "string"
          },
          "origin": {
            "type": "string"
          },
          "refresh": {
            "$ref": "#/components/schemas/CatalogueRefresh"
          },
          "services": {
            "description": "Services this source contributes to the catalogue in service.",
            "format": "int64",
            "type": "integer"
          },
          "shadowed": {
            "description": "Imported services left out because the kudurru catalogue has the same ID (kudurru's entry wins).",
            "format": "int64",
            "type": "integer"
          },
          "skipped": {
            "description": "Imported entries left out: an ID kudurru cannot use, a duplicate, no name, or no usable rule.",
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "id",
          "name",
          "license",
          "origin",
          "loaded",
          "services"
        ],
        "type": "object"
      },
      "ClientItem": {
        "additionalProperties": false,
        "properties": {
          "blocked": {
            "format": "int64",
            "type": "integer"
          },
          "count": {
            "format": "int64",
            "type": "integer"
          },
          "group": {
            "type": "string"
          },
          "key": {
            "type": "string"
          },
          "last_seen": {
            "description": "The newest query from the client on this node (hour precision once its query rows aged out).",
            "format": "date-time",
            "type": "string"
          },
          "name": {
            "type": "string"
          }
        },
        "required": [
          "key",
          "count",
          "blocked"
        ],
        "type": "object"
      },
      "ClientKey": {
        "additionalProperties": false,
        "properties": {
          "key": {
            "type": "string"
          },
          "name": {
            "type": "string"
          }
        },
        "required": [
          "key"
        ],
        "type": "object"
      },
      "ClientPoint": {
        "additionalProperties": false,
        "properties": {
          "counts": {
            "items": {
              "format": "int64",
              "type": "integer"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "ts": {
            "format": "date-time",
            "type": "string"
          }
        },
        "required": [
          "ts",
          "counts"
        ],
        "type": "object"
      },
      "ClientTimeseriesBody": {
        "additionalProperties": false,
        "properties": {
          "approximate": {
            "type": "boolean"
          },
          "clients": {
            "items": {
              "$ref": "#/components/schemas/ClientKey"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "from": {
            "format": "date-time",
            "type": "string"
          },
          "nodes": {
            "items": {
              "$ref": "#/components/schemas/NodeResult"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "partial": {
            "type": "boolean"
          },
          "points": {
            "items": {
              "$ref": "#/components/schemas/ClientPoint"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "scope": {
            "type": "string"
          },
          "step": {
            "format": "int64",
            "type": "integer"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "until": {
            "format": "date-time",
            "type": "string"
          }
        },
        "required": [
          "step",
          "clients",
          "points",
          "approximate",
          "scope",
          "nodes",
          "partial",
          "from",
          "until",
          "took_ms"
        ],
        "type": "object"
      },
      "ClusterInfo": {
        "additionalProperties": false,
        "properties": {
          "clusterID": {
            "type": "string"
          },
          "driver": {
            "type": "string"
          },
          "epoch": {
            "format": "int64",
            "minimum": 0,
            "type": "integer"
          },
          "leader": {
            "type": "string"
          },
          "node": {
            "type": "string"
          },
          "nodes": {
            "format": "int64",
            "type": "integer"
          },
          "readOnly": {
            "type": "boolean"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "driver",
          "epoch",
          "nodes",
          "readOnly",
          "node",
          "took_ms"
        ],
        "type": "object"
      },
      "Condition": {
        "additionalProperties": false,
        "properties": {
          "lastTransitionTime": {
            "format": "date-time",
            "type": "string"
          },
          "message": {
            "type": "string"
          },
          "observedGeneration": {
            "format": "int64",
            "type": "integer"
          },
          "reason": {
            "type": "string"
          },
          "status": {
            "type": "string"
          },
          "type": {
            "type": "string"
          }
        },
        "required": [
          "type",
          "status",
          "lastTransitionTime",
          "reason",
          "message"
        ],
        "type": "object"
      },
      "CreateTokenRequest": {
        "additionalProperties": false,
        "properties": {
          "description": {
            "description": "Free text shown in the token list.",
            "type": "string"
          },
          "expiresIn": {
            "description": "Go duration (720h); empty means auth.tokens.maxLifetime, or never.",
            "type": "string"
          },
          "scopes": {
            "description": "Narrow the token to these grants in wire form (viewer, zone-admin@zone:home-example-com); empty keeps the owner's grants.",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          }
        },
        "type": "object"
      },
      "CreatedToken": {
        "additionalProperties": false,
        "properties": {
          "createdAt": {
            "format": "date-time",
            "type": "string"
          },
          "description": {
            "type": "string"
          },
          "expiresAt": {
            "description": "null: the token never expires.",
            "format": "date-time",
            "type": [
              "string",
              "null"
            ]
          },
          "id": {
            "type": "string"
          },
          "lastUsedAt": {
            "format": "date-time",
            "type": "string"
          },
          "lastUsedIP": {
            "type": "string"
          },
          "owner": {
            "$ref": "#/components/schemas/TokenOwner"
          },
          "scopes": {
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "token": {
            "description": "The kdr_ secret, shown only in this answer.",
            "type": "string"
          }
        },
        "required": [
          "token",
          "id",
          "owner",
          "createdAt",
          "expiresAt"
        ],
        "type": "object"
      },
      "DNSFlags": {
        "additionalProperties": false,
        "properties": {
          "aa": {
            "type": "boolean"
          },
          "ad": {
            "type": "boolean"
          },
          "cd": {
            "type": "boolean"
          },
          "ra": {
            "type": "boolean"
          },
          "rd": {
            "type": "boolean"
          },
          "tc": {
            "type": "boolean"
          }
        },
        "required": [
          "aa",
          "tc",
          "rd",
          "ra",
          "ad",
          "cd"
        ],
        "type": "object"
      },
      "DNSQueryRequest": {
        "additionalProperties": false,
        "properties": {
          "client": {
            "type": "string"
          },
          "dnssec": {
            "type": "boolean"
          },
          "name": {
            "maxLength": 255,
            "minLength": 1,
            "type": "string"
          },
          "proto": {
            "enum": [
              "udp",
              "tcp",
              "dot",
              "doh",
              "doq",
              "doh3"
            ],
            "type": "string"
          },
          "type": {
            "type": "string"
          }
        },
        "required": [
          "name"
        ],
        "type": "object"
      },
      "DNSQueryResult": {
        "additionalProperties": false,
        "properties": {
          "additional": {
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "answer": {
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "authority": {
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "client": {
            "type": "string"
          },
          "error": {
            "type": "string"
          },
          "flags": {
            "$ref": "#/components/schemas/DNSFlags"
          },
          "latency_ms": {
            "format": "double",
            "type": "number"
          },
          "list": {
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "node": {
            "type": "string"
          },
          "rcode": {
            "type": "string"
          },
          "rule": {
            "type": "string"
          },
          "status": {
            "type": "string"
          },
          "status_class": {
            "type": "string"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "type": {
            "type": "string"
          },
          "upstream": {
            "type": "string"
          }
        },
        "required": [
          "name",
          "type",
          "client",
          "rcode",
          "status",
          "status_class",
          "answer",
          "authority",
          "additional",
          "flags",
          "latency_ms",
          "node",
          "took_ms"
        ],
        "type": "object"
      },
      "DiagnosisMessage": {
        "additionalProperties": false,
        "properties": {
          "hint": {
            "type": "string"
          },
          "message": {
            "type": "string"
          },
          "node": {
            "type": "string"
          },
          "object": {
            "type": "string"
          },
          "reason": {
            "type": "string"
          },
          "severity": {
            "enum": [
              "error",
              "warning",
              "info"
            ],
            "type": "string"
          },
          "source": {
            "type": "string"
          }
        },
        "required": [
          "severity",
          "source",
          "reason",
          "message",
          "node"
        ],
        "type": "object"
      },
      "DoctorCheck": {
        "additionalProperties": false,
        "properties": {
          "check": {
            "type": "string"
          },
          "message": {
            "type": "string"
          },
          "status": {
            "enum": [
              "ok",
              "warn",
              "fail"
            ],
            "type": "string"
          }
        },
        "required": [
          "check",
          "status",
          "message"
        ],
        "type": "object"
      },
      "DoctorReport": {
        "additionalProperties": false,
        "properties": {
          "checks": {
            "items": {
              "$ref": "#/components/schemas/DoctorCheck"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "failures": {
            "format": "int64",
            "type": "integer"
          },
          "node": {
            "type": "string"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "version": {
            "type": "string"
          },
          "warnings": {
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "node",
          "version",
          "checks",
          "failures",
          "warnings",
          "took_ms"
        ],
        "type": "object"
      },
      "DomainEntries": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/DomainEntry"
            },
            "type": "array"
          },
          "lists": {
            "items": {
              "$ref": "#/components/schemas/DomainListInfo"
            },
            "type": "array"
          },
          "matched": {
            "description": "Entries matching the filters.",
            "format": "int64",
            "type": "integer"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "total": {
            "description": "Entries of the action(s) and namespace(s), before filters.",
            "format": "int64",
            "type": "integer"
          },
          "unattached": {
            "description": "Policies that should reference a list but are managed by a file or an integration; add the list there.",
            "items": {
              "$ref": "#/components/schemas/DomainUnattached"
            },
            "type": "array"
          }
        },
        "required": [
          "items",
          "total",
          "matched",
          "lists",
          "unattached",
          "took_ms"
        ],
        "type": "object"
      },
      "DomainEntriesBatch": {
        "additionalProperties": false,
        "properties": {
          "ids": {
            "items": {
              "type": "string"
            },
            "maxItems": 1000,
            "minItems": 1,
            "type": [
              "array",
              "null"
            ]
          },
          "op": {
            "enum": [
              "enable",
              "disable",
              "delete"
            ],
            "type": "string"
          }
        },
        "required": [
          "ids",
          "op"
        ],
        "type": "object"
      },
      "DomainEntriesCreate": {
        "additionalProperties": false,
        "properties": {
          "comment": {
            "maxLength": 500,
            "type": "string"
          },
          "enabled": {
            "description": "Default true.",
            "type": "boolean"
          },
          "groups": {
            "description": "ClientGroups (ns/name or a name in namespace); empty applies to everyone.",
            "items": {
              "type": "string"
            },
            "maxItems": 100,
            "type": [
              "array",
              "null"
            ]
          },
          "list": {
            "description": "Switch the value off in this list only (a list exception) instead of adding an entry: ns/name or a name in namespace.",
            "maxLength": 300,
            "type": "string"
          },
          "namespace": {
            "description": "Default the server's default namespace.",
            "type": "string"
          },
          "origin": {
            "description": "Where the entry was added from (default manual).",
            "enum": [
              "manual",
              "querylog",
              "api"
            ],
            "type": "string"
          },
          "source": {
            "description": "With list: only this source (default every source that has the value).",
            "maxLength": 300,
            "type": "string"
          },
          "type": {
            "description": "Default exact.",
            "enum": [
              "exact",
              "wildcard",
              "regex"
            ],
            "type": "string"
          },
          "values": {
            "description": "One entry per value, all of one type.",
            "items": {
              "type": "string"
            },
            "maxItems": 1000,
            "minItems": 1,
            "type": [
              "array",
              "null"
            ]
          }
        },
        "required": [
          "values"
        ],
        "type": "object"
      },
      "DomainEntry": {
        "additionalProperties": false,
        "properties": {
          "action": {
            "enum": [
              "allow",
              "deny"
            ],
            "type": "string"
          },
          "comment": {
            "type": "string"
          },
          "created": {
            "format": "date-time",
            "type": "string"
          },
          "createdBy": {
            "description": "The actor that added the entry (user:alice).",
            "type": "string"
          },
          "enabled": {
            "type": "boolean"
          },
          "everyone": {
            "description": "Applies to every client (stored in ui-allow / ui-deny).",
            "type": "boolean"
          },
          "groups": {
            "description": "ClientGroups (ns/name) with a group-scoped copy.",
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "id": {
            "description": "Opaque, URL-safe identifier for /allowlist/{id} and /denylist/{id}.",
            "type": "string"
          },
          "kind": {
            "description": "entry: an Allowlist or Denylist entry. exception: an entry of the list in lists[0] switched off there (spec.sources[].exclude); it only affects that list, its switch is the exclusion (off switches the list's entry back on) and nothing else of it can be edited.",
            "enum": [
              "entry",
              "exception"
            ],
            "type": "string"
          },
          "lists": {
            "items": {
              "$ref": "#/components/schemas/DomainEntryList"
            },
            "type": "array"
          },
          "modified": {
            "format": "date-time",
            "type": "string"
          },
          "namespace": {
            "type": "string"
          },
          "origin": {
            "description": "list for an exception.",
            "enum": [
              "manual",
              "querylog",
              "unblock",
              "api",
              "migrated",
              "list"
            ],
            "type": "string"
          },
          "overrides": {
            "items": {
              "$ref": "#/components/schemas/DomainOverride"
            },
            "type": "array"
          },
          "policies": {
            "description": "Policies that reference the entry's lists, ns/name.",
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "readOnly": {
            "type": "boolean"
          },
          "readOnlyReason": {
            "type": "string"
          },
          "request": {
            "description": "The UnblockRequest (ns/name) whose approval added the entry.",
            "type": "string"
          },
          "rule": {
            "description": "The rule as compiled and shown in the query log: name, *.name or /expression/.",
            "type": "string"
          },
          "stillMatchedBy": {
            "description": "exception only: other lists that still match the name; the exception does not affect them.",
            "items": {
              "$ref": "#/components/schemas/DomainOverride"
            },
            "type": "array"
          },
          "type": {
            "enum": [
              "exact",
              "wildcard",
              "regex"
            ],
            "type": "string"
          },
          "value": {
            "description": "exact: ads.example.com; wildcard: *.example.com; regex: the RE2 expression without slashes.",
            "type": "string"
          }
        },
        "required": [
          "id",
          "kind",
          "action",
          "namespace",
          "value",
          "type",
          "rule",
          "enabled",
          "everyone",
          "groups",
          "lists",
          "policies",
          "origin",
          "overrides",
          "stillMatchedBy",
          "readOnly"
        ],
        "type": "object"
      },
      "DomainEntryList": {
        "additionalProperties": false,
        "properties": {
          "group": {
            "description": "The ClientGroup of a group list, ns/name.",
            "type": "string"
          },
          "list": {
            "description": "The BlockList, ns/name (ui-allow, ui-deny, ui-allow-\u003cgroup\u003e, ui-deny-\u003cgroup\u003e).",
            "type": "string"
          },
          "managedBy": {
            "description": "The list's owner when not the API.",
            "type": "string"
          },
          "source": {
            "description": "The source holding the entry (ui).",
            "type": "string"
          }
        },
        "required": [
          "list",
          "source"
        ],
        "type": "object"
      },
      "DomainEntryPatch": {
        "additionalProperties": false,
        "properties": {
          "comment": {
            "maxLength": 500,
            "type": "string"
          },
          "enabled": {
            "type": "boolean"
          },
          "groups": {
            "items": {
              "type": "string"
            },
            "maxItems": 100,
            "type": [
              "array",
              "null"
            ]
          },
          "scope": {
            "description": "everyone, or groups (with groups).",
            "enum": [
              "everyone",
              "groups"
            ],
            "type": "string"
          },
          "type": {
            "enum": [
              "exact",
              "wildcard",
              "regex"
            ],
            "type": "string"
          },
          "value": {
            "maxLength": 1024,
            "type": "string"
          }
        },
        "type": "object"
      },
      "DomainListInfo": {
        "additionalProperties": false,
        "properties": {
          "action": {
            "enum": [
              "allow",
              "deny"
            ],
            "type": "string"
          },
          "enabled": {
            "description": "The list's kudurru.io/enabled switch.",
            "type": "boolean"
          },
          "entries": {
            "format": "int64",
            "type": "integer"
          },
          "group": {
            "type": "string"
          },
          "list": {
            "type": "string"
          },
          "managedBy": {
            "type": "string"
          },
          "policies": {
            "items": {
              "type": "string"
            },
            "type": "array"
          }
        },
        "required": [
          "list",
          "action",
          "enabled",
          "entries",
          "policies"
        ],
        "type": "object"
      },
      "DomainOverride": {
        "additionalProperties": false,
        "properties": {
          "list": {
            "description": "The compiled list, ns/name.",
            "type": "string"
          },
          "rule": {
            "description": "The rule of that list that matches the name.",
            "type": "string"
          }
        },
        "required": [
          "list",
          "rule"
        ],
        "type": "object"
      },
      "DomainUnattached": {
        "additionalProperties": false,
        "properties": {
          "list": {
            "type": "string"
          },
          "managedBy": {
            "type": "string"
          },
          "policy": {
            "type": "string"
          }
        },
        "required": [
          "list",
          "policy",
          "managedBy"
        ],
        "type": "object"
      },
      "DomainWriteResult": {
        "additionalProperties": false,
        "properties": {
          "attached": {
            "description": "Policies that reference the written lists.",
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "flushed": {
            "description": "Response-cache entries of the names removed on this node.",
            "format": "int64",
            "type": "integer"
          },
          "items": {
            "description": "The entries written, as stored after the write.",
            "items": {
              "$ref": "#/components/schemas/DomainEntry"
            },
            "type": "array"
          },
          "processed": {
            "$ref": "#/components/schemas/ProcessedItems"
          },
          "skipped": {
            "description": "Policies that should reference a list but are managed elsewhere.",
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "processed",
          "attached",
          "skipped",
          "flushed",
          "took_ms"
        ],
        "type": "object"
      },
      "DomainsRequest": {
        "additionalProperties": false,
        "properties": {
          "domains": {
            "items": {
              "type": "string"
            },
            "maxItems": 1000,
            "minItems": 1,
            "type": [
              "array",
              "null"
            ]
          },
          "list": {
            "type": "string"
          },
          "namespace": {
            "type": "string"
          }
        },
        "required": [
          "domains"
        ],
        "type": "object"
      },
      "EdgeBackend": {
        "additionalProperties": false,
        "properties": {
          "address": {
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "up": {
            "type": "boolean"
          }
        },
        "required": [
          "name",
          "address",
          "up"
        ],
        "type": "object"
      },
      "EdgeComponent": {
        "additionalProperties": false,
        "properties": {
          "enabled": {
            "type": "boolean"
          },
          "state": {
            "type": "string"
          }
        },
        "required": [
          "enabled"
        ],
        "type": "object"
      },
      "EdgeInfo": {
        "additionalProperties": false,
        "properties": {
          "backends": {
            "items": {
              "$ref": "#/components/schemas/EdgeBackend"
            },
            "type": "array"
          },
          "edge": {
            "$ref": "#/components/schemas/EdgeComponent"
          },
          "node": {
            "type": "string"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "vip": {
            "$ref": "#/components/schemas/EdgeComponent"
          }
        },
        "required": [
          "edge",
          "vip",
          "backends",
          "node",
          "took_ms"
        ],
        "type": "object"
      },
      "Endpoint": {
        "additionalProperties": false,
        "properties": {
          "dnsName": {
            "type": "string"
          },
          "kudurru": {
            "$ref": "#/components/schemas/EndpointExt"
          },
          "labels": {
            "additionalProperties": {
              "type": "string"
            },
            "type": "object"
          },
          "providerSpecific": {
            "items": {
              "$ref": "#/components/schemas/ProviderSpecific"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "recordTTL": {
            "format": "int64",
            "type": "integer"
          },
          "recordType": {
            "type": "string"
          },
          "setIdentifier": {
            "type": "string"
          },
          "targets": {
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          }
        },
        "required": [
          "dnsName",
          "recordType",
          "targets"
        ],
        "type": "object"
      },
      "EndpointExt": {
        "additionalProperties": false,
        "properties": {
          "comment": {
            "type": "string"
          },
          "disabled": {
            "type": "boolean"
          },
          "expiresAt": {
            "format": "date-time",
            "type": "string"
          },
          "view": {
            "type": "string"
          }
        },
        "type": "object"
      },
      "Error": {
        "additionalProperties": false,
        "properties": {
          "error": {
            "$ref": "#/components/schemas/ErrorBody"
          },
          "took_ms": {
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "error",
          "took_ms"
        ],
        "type": "object"
      },
      "ErrorBody": {
        "additionalProperties": false,
        "properties": {
          "fields": {
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "hint": {},
          "key": {
            "type": "string"
          },
          "message": {
            "type": "string"
          },
          "missing": {
            "$ref": "#/components/schemas/Missing"
          },
          "objects": {
            "items": {
              "$ref": "#/components/schemas/ObjectOwner"
            },
            "type": [
              "array",
              "null"
            ]
          }
        },
        "required": [
          "key",
          "message"
        ],
        "type": "object"
      },
      "Event": {
        "additionalProperties": false,
        "properties": {
          "action": {
            "type": "string"
          },
          "actor": {
            "$ref": "#/components/schemas/Actor"
          },
          "after": {},
          "authz": {
            "type": "string"
          },
          "before": {},
          "hash": {
            "type": "string"
          },
          "id": {
            "format": "int64",
            "type": "integer"
          },
          "manager": {
            "type": "string"
          },
          "node": {
            "type": "string"
          },
          "prev_hash": {
            "type": "string"
          },
          "reason": {
            "type": "string"
          },
          "request": {
            "$ref": "#/components/schemas/Request"
          },
          "resource": {
            "$ref": "#/components/schemas/Resource"
          },
          "result": {
            "type": "string"
          },
          "ts": {
            "format": "date-time",
            "type": "string"
          }
        },
        "required": [
          "ts",
          "actor",
          "action",
          "resource",
          "result",
          "request"
        ],
        "type": "object"
      },
      "Flags": {
        "additionalProperties": false,
        "properties": {
          "AD": {
            "type": "boolean"
          },
          "CD": {
            "type": "boolean"
          },
          "Cached": {
            "type": "boolean"
          },
          "DO": {
            "type": "boolean"
          },
          "ECS": {
            "type": "boolean"
          },
          "Prefetch": {
            "type": "boolean"
          },
          "RD": {
            "type": "boolean"
          },
          "Stale": {
            "type": "boolean"
          },
          "TC": {
            "type": "boolean"
          },
          "Traceparent": {
            "type": "boolean"
          }
        },
        "required": [
          "RD",
          "DO",
          "TC",
          "AD",
          "CD",
          "Cached",
          "Stale",
          "Prefetch",
          "ECS",
          "Traceparent"
        ],
        "type": "object"
      },
      "FlushInputBody": {
        "additionalProperties": false,
        "properties": {
          "name": {
            "type": "string"
          }
        },
        "type": "object"
      },
      "FlushResult": {
        "additionalProperties": false,
        "properties": {
          "flushed": {
            "format": "int64",
            "type": "integer"
          },
          "name": {
            "type": "string"
          },
          "node": {
            "type": "string"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "flushed",
          "node",
          "took_ms"
        ],
        "type": "object"
      },
      "IAMUser": {
        "additionalProperties": false,
        "properties": {
          "builtinAdmin": {
            "type": "boolean"
          },
          "disabled": {
            "type": "boolean"
          },
          "displayName": {
            "type": "string"
          },
          "groups": {
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "lastLoginAt": {
            "format": "date-time",
            "type": "string"
          },
          "mustChangePassword": {
            "type": "boolean"
          },
          "name": {
            "type": "string"
          },
          "passwordChangedAt": {
            "format": "date-time",
            "type": "string"
          }
        },
        "required": [
          "name",
          "builtinAdmin",
          "disabled",
          "mustChangePassword"
        ],
        "type": "object"
      },
      "IdentityProviderInfo": {
        "additionalProperties": false,
        "properties": {
          "cliClientID": {
            "type": "string"
          },
          "clientID": {
            "type": "string"
          },
          "displayName": {
            "type": "string"
          },
          "id": {
            "type": "string"
          },
          "issuer": {
            "type": "string"
          },
          "redirectURL": {
            "type": "string"
          },
          "scopes": {
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "source": {
            "enum": [
              "config",
              "object"
            ],
            "type": "string"
          }
        },
        "required": [
          "id",
          "displayName",
          "issuer",
          "clientID",
          "scopes",
          "redirectURL",
          "source"
        ],
        "type": "object"
      },
      "ImportResult": {
        "additionalProperties": false,
        "properties": {
          "created": {
            "description": "The DNSZone was created by the import.",
            "type": "boolean"
          },
          "endpoints": {
            "format": "int64",
            "type": "integer"
          },
          "recordSets": {
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "serial": {
            "format": "int32",
            "minimum": 0,
            "type": "integer"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "warnings": {
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "zone": {
            "type": "string"
          },
          "zoneName": {
            "type": "string"
          }
        },
        "required": [
          "zone",
          "zoneName",
          "created",
          "recordSets",
          "endpoints",
          "serial",
          "warnings",
          "took_ms"
        ],
        "type": "object"
      },
      "LatencySummary": {
        "additionalProperties": false,
        "properties": {
          "avg_ms": {
            "format": "double",
            "type": "number"
          },
          "p50_ms": {
            "format": "double",
            "type": "number"
          },
          "p95_ms": {
            "format": "double",
            "type": "number"
          },
          "p99_ms": {
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "avg_ms",
          "p50_ms",
          "p95_ms",
          "p99_ms"
        ],
        "type": "object"
      },
      "ListApplyResult": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/ApplyResult"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListCatalogueCategory": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/CatalogueCategory"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListCatalogueIcon": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/CatalogueIcon"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListCatalogueService": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/CatalogueService"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListClientItem": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/ClientItem"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListDiagnosisMessage": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/DiagnosisMessage"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListListSearchHit": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/ListSearchHit"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListNodeInfo": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/NodeInfo"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListSafeSearchEngine": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/SafeSearchEngine"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListSearchHit": {
        "additionalProperties": false,
        "properties": {
          "list": {
            "type": "string"
          },
          "mode": {
            "type": "string"
          },
          "rule": {
            "type": "string"
          }
        },
        "required": [
          "list",
          "mode",
          "rule"
        ],
        "type": "object"
      },
      "ListSettingKey": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/SettingKey"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListZoneRecord": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/ZoneRecord"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ListZoneSummary": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/ZoneSummary"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "LoginRequest": {
        "additionalProperties": false,
        "properties": {
          "password": {
            "type": "string"
          },
          "username": {
            "type": "string"
          }
        },
        "required": [
          "username",
          "password"
        ],
        "type": "object"
      },
      "Me": {
        "additionalProperties": false,
        "properties": {
          "csrf": {
            "type": "string"
          },
          "mustChangePassword": {
            "description": "The local user must change the password (POST /auth/password) before using the API.",
            "type": "boolean"
          },
          "permissions": {
            "additionalProperties": {
              "items": {
                "type": "string"
              },
              "type": [
                "array",
                "null"
              ]
            },
            "type": "object"
          },
          "principal": {
            "$ref": "#/components/schemas/MePrincipal"
          },
          "roles": {
            "description": "Effective grants: role, or role@kind:name for scoped grants.",
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "principal",
          "roles",
          "permissions",
          "took_ms"
        ],
        "type": "object"
      },
      "MePrincipal": {
        "additionalProperties": false,
        "properties": {
          "auth": {
            "type": "string"
          },
          "groups": {
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "id": {
            "type": "string"
          },
          "kind": {
            "type": "string"
          },
          "name": {
            "type": "string"
          }
        },
        "required": [
          "kind",
          "id",
          "name",
          "groups"
        ],
        "type": "object"
      },
      "Missing": {
        "additionalProperties": false,
        "properties": {
          "resource": {
            "type": "string"
          },
          "scope": {
            "type": "string"
          },
          "verb": {
            "type": "string"
          }
        },
        "required": [
          "resource",
          "verb",
          "scope"
        ],
        "type": "object"
      },
      "NodeHealth": {
        "additionalProperties": false,
        "properties": {
          "health": {
            "additionalProperties": {},
            "type": "object"
          },
          "node": {
            "type": "string"
          },
          "ready": {
            "type": "boolean"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "node",
          "ready",
          "health",
          "took_ms"
        ],
        "type": "object"
      },
      "NodeInfo": {
        "additionalProperties": false,
        "properties": {
          "address": {
            "type": "string"
          },
          "leader": {
            "type": "boolean"
          },
          "name": {
            "type": "string"
          },
          "ready": {
            "type": "boolean"
          },
          "self": {
            "type": "boolean"
          },
          "snapshotAge": {
            "description": "Age of the served local.db snapshot (fromSnapshot only).",
            "type": "string"
          },
          "state": {
            "description": "zonecache state: unsynced, fromSnapshot, live.",
            "type": "string"
          },
          "unready": {
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "version": {
            "type": "string"
          }
        },
        "required": [
          "name",
          "self",
          "leader"
        ],
        "type": "object"
      },
      "NodeResult": {
        "additionalProperties": false,
        "properties": {
          "error": {
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "ok": {
            "type": "boolean"
          },
          "took_ms": {
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "name",
          "ok",
          "took_ms"
        ],
        "type": "object"
      },
      "NotifyResult": {
        "additionalProperties": false,
        "properties": {
          "targets": {
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "zone": {
            "type": "string"
          }
        },
        "required": [
          "zone",
          "targets",
          "took_ms"
        ],
        "type": "object"
      },
      "ObjectList": {
        "additionalProperties": false,
        "properties": {
          "continue": {
            "description": "Opaque keyset token for the next page; empty on the last page.",
            "type": "string"
          },
          "items": {
            "items": {
              "additionalProperties": {},
              "type": "object"
            },
            "type": "array"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "took_ms"
        ],
        "type": "object"
      },
      "ObjectOwner": {
        "additionalProperties": false,
        "properties": {
          "kind": {
            "type": "string"
          },
          "managedBy": {
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "namespace": {
            "type": "string"
          }
        },
        "required": [
          "kind",
          "name"
        ],
        "type": "object"
      },
      "PasswordChangeRequest": {
        "additionalProperties": false,
        "properties": {
          "currentPassword": {
            "description": "The current password.",
            "type": "string"
          },
          "newPassword": {
            "description": "The new password (at least 12 characters, different from the current one).",
            "type": "string"
          },
          "revokeTokens": {
            "description": "Also revoke every API token of the user; a password change alone revokes sessions, not tokens.",
            "type": "boolean"
          }
        },
        "required": [
          "currentPassword",
          "newPassword"
        ],
        "type": "object"
      },
      "Point": {
        "additionalProperties": false,
        "properties": {
          "authoritative": {
            "format": "int64",
            "type": "integer"
          },
          "blocked": {
            "format": "int64",
            "type": "integer"
          },
          "cached": {
            "format": "int64",
            "type": "integer"
          },
          "forwarded": {
            "format": "int64",
            "type": "integer"
          },
          "other": {
            "format": "int64",
            "type": "integer"
          },
          "total": {
            "format": "int64",
            "type": "integer"
          },
          "ts": {
            "format": "date-time",
            "type": "string"
          }
        },
        "required": [
          "ts",
          "total",
          "blocked",
          "cached",
          "forwarded",
          "authoritative",
          "other"
        ],
        "type": "object"
      },
      "PolicyCategory": {
        "additionalProperties": false,
        "properties": {
          "allowed": {
            "description": "Of those, the ones allowedServices excepts.",
            "format": "int64",
            "type": "integer"
          },
          "icon": {
            "description": "A Lucide icon name.",
            "type": "string"
          },
          "id": {
            "type": "string"
          },
          "known": {
            "description": "The catalogue in service has the category.",
            "type": "boolean"
          },
          "name": {
            "description": "The catalogue name; the ID when unknown.",
            "type": "string"
          },
          "services": {
            "description": "Services in the category now.",
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "id",
          "name",
          "known",
          "services",
          "allowed"
        ],
        "type": "object"
      },
      "PolicyClient": {
        "additionalProperties": false,
        "properties": {
          "count": {
            "format": "int64",
            "type": "integer"
          },
          "key": {
            "type": "string"
          },
          "name": {
            "type": "string"
          }
        },
        "required": [
          "key",
          "count"
        ],
        "type": "object"
      },
      "PolicyDomain": {
        "additionalProperties": false,
        "properties": {
          "count": {
            "format": "int64",
            "type": "integer"
          },
          "domain": {
            "type": "string"
          }
        },
        "required": [
          "domain",
          "count"
        ],
        "type": "object"
      },
      "PolicyEffectiveService": {
        "additionalProperties": false,
        "properties": {
          "category": {
            "type": "string"
          },
          "icon": {
            "description": "Logo path, /api/v1/catalogue/icons/{slug}.svg; absent when there is none.",
            "type": "string"
          },
          "iconOnDark": {
            "description": "The logo drawn for dark backgrounds, when the default one is dark artwork.",
            "type": "string"
          },
          "id": {
            "type": "string"
          },
          "known": {
            "type": "boolean"
          },
          "name": {
            "type": "string"
          },
          "origin": {
            "enum": [
              "kudurru",
              "adguard"
            ],
            "type": "string"
          },
          "rules": {
            "format": "int64",
            "type": "integer"
          },
          "via": {
            "description": "service: named in blockedServices; category: a service of a blocked category.",
            "enum": [
              "service",
              "category"
            ],
            "type": "string"
          }
        },
        "required": [
          "id",
          "name",
          "known",
          "rules",
          "via",
          "origin"
        ],
        "type": "object"
      },
      "PolicyGroup": {
        "additionalProperties": false,
        "properties": {
          "clients": {
            "description": "Client matchers of the group (spec.clients).",
            "format": "int64",
            "type": "integer"
          },
          "enabled": {
            "type": "boolean"
          },
          "exists": {
            "type": "boolean"
          },
          "ref": {
            "type": "string"
          },
          "seen24h": {
            "description": "Distinct clients this node's query log attributed to the group (as their first group) in the last 24 hours; absent without a query log.",
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "ref",
          "exists",
          "enabled",
          "clients"
        ],
        "type": "object"
      },
      "PolicyList": {
        "additionalProperties": false,
        "properties": {
          "enabled": {
            "type": "boolean"
          },
          "entries": {
            "format": "int64",
            "type": "integer"
          },
          "exists": {
            "type": "boolean"
          },
          "mode": {
            "description": "The list's own spec.mode (how it is applied); the role when it does not exist.",
            "type": "string"
          },
          "ready": {
            "type": "boolean"
          },
          "ref": {
            "type": "string"
          },
          "role": {
            "description": "Which reference field names it: blockListRefs (block) or allowListRefs (allow).",
            "enum": [
              "block",
              "allow"
            ],
            "type": "string"
          },
          "sourcesEnabled": {
            "format": "int64",
            "type": "integer"
          },
          "sourcesTotal": {
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "ref",
          "role",
          "mode",
          "exists",
          "enabled",
          "ready",
          "entries",
          "sourcesEnabled",
          "sourcesTotal"
        ],
        "type": "object"
      },
      "PolicySafeSearch": {
        "additionalProperties": false,
        "properties": {
          "enabled": {
            "type": "boolean"
          },
          "engines": {
            "description": "Every engine the catalogue rewrites (all apply when enabled).",
            "items": {
              "$ref": "#/components/schemas/PolicySafeSearchEngine"
            },
            "type": "array"
          },
          "mode": {
            "enum": [
              "strict",
              "moderate"
            ],
            "type": "string"
          }
        },
        "required": [
          "enabled",
          "mode",
          "engines"
        ],
        "type": "object"
      },
      "PolicySafeSearchEngine": {
        "additionalProperties": false,
        "properties": {
          "icon": {
            "description": "Logo path, /api/v1/catalogue/icons/{slug}.svg; absent when there is none.",
            "type": "string"
          },
          "iconOnDark": {
            "description": "The logo drawn for dark backgrounds, when the default one is dark artwork.",
            "type": "string"
          },
          "id": {
            "type": "string"
          },
          "name": {
            "type": "string"
          }
        },
        "required": [
          "id",
          "name"
        ],
        "type": "object"
      },
      "PolicySchedule": {
        "additionalProperties": false,
        "properties": {
          "error": {
            "description": "Why the schedule is invalid; the policy then applies at all times.",
            "type": "string"
          },
          "nextChange": {
            "description": "When now flips next (within eight days).",
            "format": "date-time",
            "type": "string"
          },
          "now": {
            "description": "The schedule allows the policy now.",
            "type": "boolean"
          },
          "summary": {
            "description": "\"Mon-Fri 08:00-17:00 (Europe/Berlin)\"",
            "type": "string"
          }
        },
        "required": [
          "now",
          "summary"
        ],
        "type": "object"
      },
      "PolicyService": {
        "additionalProperties": false,
        "properties": {
          "icon": {
            "description": "Logo path, /api/v1/catalogue/icons/{slug}.svg; absent when there is none.",
            "type": "string"
          },
          "iconOnDark": {
            "description": "The logo drawn for dark backgrounds, when the default one is dark artwork.",
            "type": "string"
          },
          "id": {
            "type": "string"
          },
          "known": {
            "description": "The catalogue in service has the ID.",
            "type": "boolean"
          },
          "name": {
            "description": "The catalogue name; the ID when unknown.",
            "type": "string"
          },
          "rules": {
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "id",
          "name",
          "known",
          "rules"
        ],
        "type": "object"
      },
      "PolicyState": {
        "additionalProperties": false,
        "properties": {
          "active": {
            "description": "enabled and the schedule allows it now (an invalid schedule applies at all times).",
            "type": "boolean"
          },
          "allowedServices": {
            "description": "The spec.allowedServices entries: services of a blocked category this policy does not block.",
            "items": {
              "$ref": "#/components/schemas/PolicyService"
            },
            "type": "array"
          },
          "blockMode": {
            "description": "spec.blockMode, else blocking.defaultResponse; a BlockList's own response still overrides it for that list.",
            "type": "string"
          },
          "blockTTL": {
            "type": "string"
          },
          "categories": {
            "description": "The spec.blockedCategories entries.",
            "items": {
              "$ref": "#/components/schemas/PolicyCategory"
            },
            "type": "array"
          },
          "conditions": {
            "items": {
              "$ref": "#/components/schemas/Condition"
            },
            "type": "array"
          },
          "effectiveServices": {
            "description": "Every service the policy blocks with the catalogue in service: blockedServices, then the services of blockedCategories minus allowedServices.",
            "items": {
              "$ref": "#/components/schemas/PolicyEffectiveService"
            },
            "type": "array"
          },
          "enabled": {
            "description": "false while the kudurru.io/enabled annotation is \"false\".",
            "type": "boolean"
          },
          "groups": {
            "items": {
              "$ref": "#/components/schemas/PolicyGroup"
            },
            "type": "array"
          },
          "lists": {
            "items": {
              "$ref": "#/components/schemas/PolicyList"
            },
            "type": "array"
          },
          "managedBy": {
            "type": "string"
          },
          "policy": {
            "description": "namespace/name",
            "type": "string"
          },
          "priority": {
            "format": "int64",
            "type": "integer"
          },
          "safeSearch": {
            "$ref": "#/components/schemas/PolicySafeSearch"
          },
          "schedule": {
            "$ref": "#/components/schemas/PolicySchedule"
          },
          "services": {
            "description": "The spec.blockedServices entries.",
            "items": {
              "$ref": "#/components/schemas/PolicyService"
            },
            "type": "array"
          },
          "shadowedBy": {
            "description": "Enabled policies (namespace/name, rank order) that outrank this one for at least one of its client groups: they decide for those clients and their settings win; the lists of all active policies still apply.",
            "items": {
              "type": "string"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "stats24h": {
            "$ref": "#/components/schemas/PolicyStats24h"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "upstreamGroup": {
            "$ref": "#/components/schemas/PolicyUpstreamGroup"
          }
        },
        "required": [
          "policy",
          "enabled",
          "active",
          "priority",
          "groups",
          "lists",
          "services",
          "categories",
          "allowedServices",
          "effectiveServices",
          "safeSearch",
          "blockMode",
          "conditions",
          "took_ms"
        ],
        "type": "object"
      },
      "PolicyStats24h": {
        "additionalProperties": false,
        "properties": {
          "blocked": {
            "format": "int64",
            "type": "integer"
          },
          "blockedPercent": {
            "format": "double",
            "type": "number"
          },
          "queries": {
            "format": "int64",
            "type": "integer"
          },
          "topBlocked": {
            "items": {
              "$ref": "#/components/schemas/PolicyDomain"
            },
            "type": "array"
          },
          "topClients": {
            "items": {
              "$ref": "#/components/schemas/PolicyClient"
            },
            "type": "array"
          }
        },
        "required": [
          "queries",
          "blocked",
          "blockedPercent",
          "topBlocked",
          "topClients"
        ],
        "type": "object"
      },
      "PolicyUpstreamGroup": {
        "additionalProperties": false,
        "properties": {
          "exists": {
            "description": "upstreams.groups has it; queries fall back to the default group otherwise.",
            "type": "boolean"
          },
          "name": {
            "type": "string"
          }
        },
        "required": [
          "name",
          "exists"
        ],
        "type": "object"
      },
      "Processed": {
        "additionalProperties": false,
        "properties": {
          "processed": {
            "$ref": "#/components/schemas/ProcessedItems"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "processed",
          "took_ms"
        ],
        "type": "object"
      },
      "ProcessedItem": {
        "additionalProperties": false,
        "properties": {
          "error": {
            "type": "string"
          },
          "item": {
            "type": "string"
          }
        },
        "required": [
          "item"
        ],
        "type": "object"
      },
      "ProcessedItems": {
        "additionalProperties": false,
        "properties": {
          "errors": {
            "items": {
              "$ref": "#/components/schemas/ProcessedItem"
            },
            "type": "array"
          },
          "success": {
            "items": {
              "$ref": "#/components/schemas/ProcessedItem"
            },
            "type": "array"
          }
        },
        "required": [
          "success",
          "errors"
        ],
        "type": "object"
      },
      "ProviderSpecific": {
        "additionalProperties": false,
        "properties": {
          "name": {
            "type": "string"
          },
          "value": {
            "type": "string"
          }
        },
        "required": [
          "name",
          "value"
        ],
        "type": "object"
      },
      "PurgeResult": {
        "additionalProperties": false,
        "properties": {
          "deleted": {
            "format": "int64",
            "type": "integer"
          },
          "node": {
            "type": "string"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "deleted",
          "node",
          "took_ms"
        ],
        "type": "object"
      },
      "QueriesBody": {
        "additionalProperties": false,
        "properties": {
          "cursor_next": {
            "type": "string"
          },
          "earliest_ts_disk": {
            "format": "date-time",
            "type": "string"
          },
          "earliest_ts_memory": {
            "format": "date-time",
            "type": "string"
          },
          "nodes": {
            "items": {
              "$ref": "#/components/schemas/NodeResult"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "partial": {
            "type": "boolean"
          },
          "queries": {
            "items": {
              "$ref": "#/components/schemas/QueryRow"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "records_filtered": {
            "format": "int64",
            "type": "integer"
          },
          "records_total": {
            "format": "int64",
            "type": "integer"
          },
          "scope": {
            "type": "string"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "queries",
          "records_total",
          "records_filtered",
          "scope",
          "nodes",
          "partial",
          "took_ms"
        ],
        "type": "object"
      },
      "QueryActionInputBody": {
        "additionalProperties": false,
        "properties": {
          "action": {
            "enum": [
              "allow",
              "deny"
            ],
            "type": "string"
          },
          "namespace": {
            "type": "string"
          }
        },
        "required": [
          "action"
        ],
        "type": "object"
      },
      "QueryClient": {
        "additionalProperties": false,
        "properties": {
          "group": {
            "type": "string"
          },
          "ip": {
            "type": "string"
          },
          "name": {
            "type": "string"
          }
        },
        "required": [
          "ip"
        ],
        "type": "object"
      },
      "QueryReply": {
        "additionalProperties": false,
        "properties": {
          "answer": {
            "type": "string"
          },
          "time_ms": {
            "format": "double",
            "type": "number"
          },
          "type": {
            "type": "string"
          }
        },
        "required": [
          "type"
        ],
        "type": "object"
      },
      "QueryRow": {
        "additionalProperties": false,
        "properties": {
          "client": {
            "$ref": "#/components/schemas/QueryClient"
          },
          "cname": {
            "type": "string"
          },
          "dnssec": {
            "type": "string"
          },
          "domain": {
            "type": "string"
          },
          "ecs": {
            "type": "string"
          },
          "ede": {
            "format": "int64",
            "type": "integer"
          },
          "flags": {
            "$ref": "#/components/schemas/Flags"
          },
          "id": {
            "format": "int64",
            "minimum": 0,
            "type": "integer"
          },
          "list": {
            "type": "string"
          },
          "node": {
            "type": "string"
          },
          "policy": {
            "type": "string"
          },
          "proto": {
            "type": "string"
          },
          "qclass": {
            "format": "int64",
            "type": "integer"
          },
          "qtype": {
            "type": "string"
          },
          "rcode": {
            "type": "string"
          },
          "reply": {
            "$ref": "#/components/schemas/QueryReply"
          },
          "rule": {
            "type": "string"
          },
          "status": {
            "type": "string"
          },
          "status_class": {
            "type": "string"
          },
          "trace_id": {
            "type": "string"
          },
          "ts": {
            "format": "date-time",
            "type": "string"
          },
          "upstream": {
            "type": "string"
          },
          "zone": {
            "type": "string"
          }
        },
        "required": [
          "id",
          "ts",
          "node",
          "proto",
          "client",
          "domain",
          "qtype",
          "qclass",
          "status",
          "status_class",
          "rcode",
          "reply",
          "dnssec",
          "flags"
        ],
        "type": "object"
      },
      "QuerylogStatusBody": {
        "additionalProperties": false,
        "properties": {
          "db_bytes": {
            "format": "int64",
            "type": "integer"
          },
          "nodes": {
            "items": {
              "$ref": "#/components/schemas/NodeResult"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "oldest_ts": {
            "format": "date-time",
            "type": "string"
          },
          "partial": {
            "type": "boolean"
          },
          "privacy": {
            "type": "string"
          },
          "retention": {
            "$ref": "#/components/schemas/Retention"
          },
          "rows": {
            "format": "int64",
            "type": "integer"
          },
          "scope": {
            "type": "string"
          },
          "subscribers": {
            "format": "int64",
            "type": "integer"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          },
          "wal_bytes": {
            "format": "int64",
            "type": "integer"
          },
          "writer": {
            "$ref": "#/components/schemas/Stats"
          }
        },
        "required": [
          "rows",
          "db_bytes",
          "wal_bytes",
          "privacy",
          "retention",
          "writer",
          "subscribers",
          "scope",
          "nodes",
          "partial",
          "took_ms"
        ],
        "type": "object"
      },
      "RecentBlockedBody": {
        "additionalProperties": false,
        "properties": {
          "items": {
            "items": {
              "$ref": "#/components/schemas/BlockedItem"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "nodes": {
            "items": {
              "$ref": "#/components/schemas/NodeResult"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "partial": {
            "type": "boolean"
          },
          "scope": {
            "type": "string"
          },
          "took_ms": {
            "description": "Server-side duration of the request in milliseconds.",
            "format": "double",
            "type": "number"
          }
        },
        "required": [
          "items",
          "scope",
          "nodes",
          "partial",
          "took_ms"
        ],
        "type": "object"
      },
      "RecordBody": {
        "additionalProperties": false,
        "properties": {
          "dnsName": {
            "type": "string"
          },
          "kudurru": {
            "$ref": "#/components/schemas/EndpointExt"
          },
          "labels": {
            "additionalProperties": {
              "type": "string"
            },
            "type": "object"
          },
          "managedBy": {
            "type": "string"
          },
          "recordSet": {
            "type": "string"
          },
          "recordTTL": {
            "format": "int64",
            "type": "integer"
          },
          "recordType": {
            "type": "string"
          },
[...]
